/*
COPYRIGHT (C) 2003  Lorenzo Dozio (dozio@aero.polimi.it)
                    Paolo Mantegazza (mantegazza@aero.polimi.it)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
*/

#ifndef _PARAMETERSPANEL_H
#define _PARAMETERSPANEL_H

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Button.H>
#include <stdio.h>
#include <time.h>

class ParametersPanel
{
	public:
		ParametersPanel();
		void show();
		void hide();
		int IsBatch();
		int UpdateParameter(int, double, struct tm *);
		int BatchCounter();
		int increment_BatchCounter();
		void GetParameters();
	private:
		Fl_Window *Window;
		Fl_Group *ParamsInfo;
		Fl_Scroll *ParamsScroll;
		Fl_Input **Entry;
		Fl_Check_Button *BatchDownload;
		Fl_Button *Download;
		Fl_Button *GetP;
		Fl_Check_Button *LogP;
		char *LogFileName;
		FILE *LogFile;
		int LogFlag;
		int counter;
		void LogTimeAndNames(int, struct tm *);
		inline void cb_batchdownload_i(Fl_Check_Button *, void *);
		static void cb_batchdownload(Fl_Check_Button *, void *);
		inline void cb_log_parameters_i(Fl_Check_Button *, void *);
		static void cb_log_parameters(Fl_Check_Button *, void *);
		inline void cb_close_i(Fl_Button *, void *);
		static void cb_close(Fl_Button *, void *);
};

#endif
