/*
COPYRIGHT (C) 2003  Roberto Bucher (roberto.bucher@die.supsi.ch)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
*/

static struct{
    double Amplitude;
    double Period;
    double bias;
    double SemiPeriod;
    double delay;
}square[10];

static int isUpPeriod(double t,double P,double S)
{
    double val;
    val=t/P;
    val=(val-(int) val)*P;
    if ((1.0*val) < S) return 1;
    else               return 0;
}
 
void inp_square_init(int port,double A, double P, double S, double b, double d)
{
    square[port].Amplitude=A;
    square[port].Period=P;
    square[port].bias=b;
    square[port].SemiPeriod=S;
    square[port].delay=d;
}

void inp_square_input(int port, double * y, double t)
{
    if(t<square[port].delay) y[0]=0.0;
else
    y[0]=square[port].Amplitude*isUpPeriod(t-square[port].delay,square[port].Period,square[port].SemiPeriod)+square[port].bias;
}

void inp_square_update()
{
}

void inp_square_end()
{
}
