/***************************************************************************
                          rtai_scope.c  -  description
                          ----------------------------
    begin                : Jan 30 2003
    copyright            : (C) 2001 by Roberto Bucher
                           University of Applied Sciences 
                           of Southern Switzerland (SUPSI)                     
                           Dept. of cs and ee (DIE)

    email                : bucher@die.supsi.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "net_rpc.h"
#include "krtmain.h"

#define MAX_RTAI_SCOPES               1000
#define MBX_RTAI_SCOPE_SIZE           5000

extern char *TargetMbxID;
MBX * mbx[10];

void rtai_scope_init(int port,int ntraces,char * scName)
{
    char name[7];
    int nt=ntraces+1;
    rtRegisterScope(scName,ntraces);
    get_a_name(TargetMbxID,name);
#ifdef __KERNEL__
    mbx[port]=RT_typed_named_mbx_init(0,0,name,(5000/(nt*sizeof(float)))*(nt*sizeof(float)),FIFO_Q);
#else
    mbx[port]=rt_mbx_init(nam2num(name),(5000/(nt*sizeof(float)))*(nt*sizeof(float)));
#endif
}

void rtai_scope_output(int port, int ntraces,double * u, double t)
{
    struct {
	float t;
        float u[ntraces];
    } data;
    int i;

    data.t=(float) t;
    for (i = 0; i < ntraces; i++) {
	data.u[i] = (float) u[i];
    }
#ifdef __KERNEL__
    RT_mbx_send_if(0,0,mbx[port],&data,sizeof(data));
#else
    rt_mbx_send_if(mbx[port],&data,sizeof(data));
#endif
}

void rtai_scope_end(int port)
{
#ifdef __KERNEL__
    RT_named_mbx_delete(0,0,mbx[port]);
#else
    rt_mbx_delete(mbx[port]);
#endif
}



