/*
COPYRIGHT (C) 2003  Roberto Bucher (roberto.bucher@die.supsi.ch)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
*/

#include <stdio.h>
#include <string.h>
#include "genconf_io.h"

extern FILE * fin;

void fill_rtai_scope()
{
    int port,ntraces;
    char name[20];
    char str_init[40];
    char str_out[40];
    char str_end[40];

    fscanf(fin,"%d",&port);
    fscanf(fin,"%d",&ntraces);
    fscanf(fin,"%s",name);
    sprintf(str_init,"rtai_scope_init(%d,%d,\"%s\");",port,ntraces,name);
    sprintf(str_out,"rtai_scope_output(%d,%d,u,*t);",port,ntraces);
    sprintf(str_end,"rtai_scope_end(%d);",port);
    write_act(port,str_init,str_out,str_end);
}

void fill_da_epp()
{
    int port,channel;
    char str_init[40];
    char str_out[40];
    char str_end[40];
    fscanf(fin,"%d",&port);
    fscanf(fin,"%d",&channel);
    sprintf(str_init,"da_epp_init();");
    sprintf(str_out,"da_epp_output(%d,u);",channel);
    sprintf(str_end,"da_epp_end(%d);",channel);
    write_act(port,str_init,str_out,str_end);
}

void fill_dapci1200()
{
    int port,channel;
    char str_init[40];
    char str_out[40];
    char str_end[40];
    fscanf(fin,"%d",&port);
    fscanf(fin,"%d",&channel);
    sprintf(str_init,"dapci1200_init();");
    sprintf(str_out,"dapci1200_output(%d,u);",channel);
    sprintf(str_end,"dapci1200_end(%d);",channel);
    write_act(port,str_init,str_out,str_end);
}

void fill_inp_square()
{
    int port;
    double Amplitude, Period, SemiPeriod, bias,delay;
    char str_init[40];
    char str_inp[40];
    char str_end[40];
    char str_upd[40];

    fscanf(fin,"%d",&port);
    fscanf(fin,"%lf",&Amplitude);
    fscanf(fin,"%lf",&Period);
    fscanf(fin,"%lf",&SemiPeriod);
    fscanf(fin,"%lf",&bias);
    fscanf(fin,"%lf",&delay);
    sprintf(str_init,"inp_square_init(%d,%lf,%lf,%lf,%lf,%lf);",port,
	    Amplitude,Period,SemiPeriod,bias,delay);
    sprintf(str_inp,"inp_square_input(%d,y,*t);",port);
    sprintf(str_upd,"inp_square_update();");
    sprintf(str_end,"inp_square_end();");
    write_sens(port,str_init,str_inp,str_upd,str_end);
}

void fill_inp_step()
{
    int port;
    double Amplitude, t_init;
    char str_init[40];
    char str_inp[40];
    char str_end[40];
    char str_upd[40];

    fscanf(fin,"%d",&port);
    fscanf(fin,"%lf",&Amplitude);
    fscanf(fin,"%lf",&t_init);
    sprintf(str_init,"inp_step_init(%d,%lf,%lf);",port,
	    Amplitude,t_init);
    sprintf(str_inp,"inp_step_input(%d,y,*t);",port);
    sprintf(str_upd,"inp_step_update();");
    sprintf(str_end,"inp_step_end();");
    write_sens(port,str_init,str_inp,str_upd,str_end);
}

void fill_ad_epp()
{
    int port,channel;
    char str_init[40];
    char str_inp[40];
    char str_end[40];
    char str_upd[40];

    fscanf(fin,"%d",&port);
    fscanf(fin,"%d",&channel);
    sprintf(str_init,"ad_epp_init();");
    sprintf(str_inp,"ad_epp_input(%d,y);",channel);
    sprintf(str_upd,"ad_epp_update();");
    sprintf(str_end,"ad_epp_end();");
    write_sens(port, str_init,str_inp,str_upd,str_end);
}

void fill_cioquad4()
{
    int port,module,res,mode,count,rot;
    char str_init[40];
    char str_inp[40];
    char str_end[40];
    char str_upd[40];

    fscanf(fin,"%d",&port);
    fscanf(fin,"%d",&module);
    fscanf(fin,"%d",&res);
    fscanf(fin,"%d",&mode);
    fscanf(fin,"%d",&count);
    fscanf(fin,"%d",&rot);

    sprintf(str_init,"cioquad4_init(%d,%d,%d,%d,%d,%d);",port,module,res,mode,count,rot);
    sprintf(str_inp,"cioquad4_input(%d,y);",port);
    sprintf(str_upd,"cioquad4_update();");
    sprintf(str_end,"cioquad4_end();");
    write_sens(port, str_init,str_inp,str_upd,str_end);
}

void fill_peak_canout()
{
    int port,id;
    char name[20];
    char str_init[40];
    char str_out[40];
    char str_end[40];

    fscanf(fin,"%d",&port);
    fscanf(fin,"%x",&id);
    fscanf(fin,"%s",name);
    sprintf(str_init,"peak_canout_init(%d,%d,\"%s\");",port,id,name);
    sprintf(str_out,"peak_canout_output(%d,u,*t);",port);
    sprintf(str_end,"peak_canout_end(%d);",port);
    write_act(port,str_init,str_out,str_end);
}

