/*
COPYRIGHT (C) 2003  Lorenzo Dozio (dozio@aero.polimi.it)
                    Paolo Mantegazza (mantegazza@aero.polimi.it)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
*/

#ifndef _SCOPEWINDOW_H_
#define _SCOPEWINDOW_H_

#include <FL/Fl_Input.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Widget.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Light_Button.H>
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Int_Input.H>
#include <FL/Fl_Secret_Input.H>
#include <FL/Fl_Dial.H>
#include <FL/Fl_Color_Chooser.H>
#include <FL/forms.H>
#include "scopecanvas.h"
#include "rtailab.h"

#define rtScopeUI_width		1795
#define rtScopeUI_height        380

typedef struct LocalMsg {
        ScopeCanvas *s;
        int n;
};

class ScopeWindow
{
	public:
		ScopeWindow(int n, char *name, int ntr, float samp_freq);
		~ScopeWindow();
		void show();
		void hide();
		ScopeCanvas *Scope;
		Fl_Window *scpWin;
		void getTargetTime(float time);

	private:

		Fl_Group *PlotArea;
		Fl_Box *PlotBox;

		Fl_Group *CommonArea;
		Fl_Box *CommonBox;
		Fl_Box *TargetTime;
		Fl_Box *TargetTimeLabel;
		Fl_Dial *SecDivDial;
		Fl_Check_Button *PauseButton;
		Fl_Check_Button *OneShotButton;
		Fl_Button *BgColorButton;
		Fl_Button *GridColorButton;

		Fl_Group *ChannelArea[MAX_CHANNELS];
		Fl_Box *ChannelBox[MAX_CHANNELS];
		Fl_Dial *UnitsDivDial[MAX_CHANNELS];
		Fl_Dial *PosDial[MAX_CHANNELS];
		Fl_Check_Button *ShowButton[MAX_CHANNELS];
		Fl_Button *AutoScaleButton[MAX_CHANNELS];
		Fl_Button *TraceColorButton[MAX_CHANNELS];
};

#endif
