/*
COPYRIGHT (C) 2003  Lorenzo Dozio (dozio@aero.polimi.it)
                    Paolo Mantegazza (mantegazza@aero.polimi.it)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
*/

#ifndef _TARGETPANEL_H
#define _TARGETPANEL_H

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Preferences.H>
#include <FL/Fl_Button.H>

class TargetPanel
{
        public:
                TargetPanel();
                char *getIP();
                char *getIfTaskID();
                char *getScopeID();
                char *getLogID();
                void show();
                void hide();
        private:
                Fl_Window *Window;
                Fl_Group *TargetInfo;
                Fl_Input *IPaddress;
                Fl_Preferences *IPaddrPref;
                Fl_Input *InterfaceTaskID;
                Fl_Preferences *IfTaskIDPref;
                Fl_Input *ScopeMbxID;
                Fl_Preferences *ScopeIDPref;
                Fl_Input *LogMbxID;
                Fl_Preferences *LogIDPref;
                Fl_Group *Buttons;
                Fl_Button *Ok, *Cancel;
                inline void cb_ok_i(Fl_Button *, void *);
                static void cb_ok(Fl_Button *, void *);
                inline void cb_cancel_i(Fl_Button *, void *);
		static void cb_cancel(Fl_Button *, void *);
};

#endif
